'**************************************
'*  VGA 800 x 600 - 8bit bitmap bars  *
'**************************************

' P4 = VSYNC
' P3 = RED
' P2 = GREEN
' P1 = BLUE
' P0 = HSYNC

CON

  _clkmode = xinput
  _xinfreq = 60_000_000

  s = 44        'scales DAC output (s = 0..128)

' ptra[0] = VSYNC_HUB
' ptra[1] = VIDEO_SDRAM_PTR
' ptra[2] = SDRAM_COMMANDS
' ptra[3] = HUB_BUFFER

DAT

                org     0
VGA_Driver      rdlong  vbptr,ptra++
                rdlong  vidramptr,ptra++
                rdlong  hubram_loc,ptra++
                mov     sdram_loc,hubram_loc
                add     sdram_loc,#4
                rdlong  hubram_addr,ptra++
                mov     hubram_ptr,hubram_addr
                add     hubram_ptr,#7

                setctra #%00111                 'set ctra for PLL*8
                setfrqa frqa_                   'set frqa

                setvid  #%0100                  'set vid for vga output
                setvidy vidy_                   'set yiq coefficients
                setvidi vidi_
                setvidq vidq_

                cfgdacs #%11_11_11_11           'set dacs to video mode

                cfgpins pinmask,pindacs         'set pins for dac outputs
'
'
' Field loop
'
field           mov     x,#23                   'top blanks
                call    #blank

                rdlong  sdram_ptr,vidramptr
                wrlong  sdram_ptr,sdram_loc
                add     sdram_ptr,sdram_add
                wrlong  hubram_ptr,hubram_loc

                mov     x,lines_vis             'set visible lines
line            call    #sync                   'do horizontal sync

                waitvid mode,#0                 '256*5 clocks per waitvid - show luma/colorbars

                setptra hubram_addr
                reps    #800/4,#2
                setspa  #$00
                rdlongc v,ptra++
                pusha   v

                rdlong  v,hubram_loc
                tjnz    v,#$-1
                wrlong  sdram_ptr,sdram_loc
                add     sdram_ptr,sdram_add
                wrlong  hubram_ptr,hubram_loc

                djnz    x,#line                 'another line?

                wrlong  vone,vbptr

                mov     x,#1                    'bottom blanks
                call    #blank

                setp    #0                      'do vertical sync
                mov     x,#4
                call    #blank
                clrp    #0

                jmp     #field                  'field loop

blank           call    #sync                   'blank lines
                waitvid v800,sync_color0
                djnz    x,#blank
blank_ret       ret

sync                                            'horizontal sync
sync_ret        retd
                waitvid v40,sync_color0
                waitvid v128,sync_color1
                waitvid v88,sync_color0
'
'
' Initialized data
'
vbptr           long    0
vidramptr       long    0
hubram_loc      long    0
sdram_loc       long    0
hubram_ptr      long    0
hubram_addr     long    0
sdram_ptr       long    0
sdram_add       long    1024

frqa_           long    $1555_5555 '$1800_0000              '45MHz

vidy_           long    $00_01_00_00 * s        'red gain
vidi_           long    $00_00_01_00 * s        'green gain
vidq_           long    $00_00_00_01 * s        'blue gain

pinmask         long    %1111                   'pin mask for P0..P3
pindacs         long    %1111_101100000         'pin configuration for video DAC

                '       color base      mode            clocks/pixel    clocks/waitvid
mode            long    $00 << 24 +     %1010 << 20 +   1 << 13 +       800

lines_vis       long    600

vzero           long    0
vone            long    1

sync_color0     long    $0_000000
sync_color1     long    $1_000000

v40             long    40
v128            long    128
v88             long    88
v800            long    800

x               long    0
v               long    0
